import * as juggler from 'loopback-datasource-juggler';
import { MetaModel, ValueTransformer } from 'sqlite3orm';
import { Sqlite3Settings } from './sqlite3-settings';
interface MetaModelRef {
    metaModel: MetaModel;
    lbModelDef?: juggler.ModelDefinition;
}
export declare class MetaModelFactory {
    private readonly settings;
    private mapNameToMetaModel;
    private readonly mapPropDefToTransform;
    /**
     * Creates an instance of MetaModelFactory.
     *
     */
    constructor(settings?: Sqlite3Settings);
    getValueTransformer(prop: juggler.PropertyDefinition): ValueTransformer | undefined;
    /**
     * get a MetaModel for a lb4 model definition
     *
     * @param modelName
     * @param lbModelDef
     * @param [recreate]
     */
    /**
     * get a MetaModel for a juggler model definition
     *
     * @param modelName
     * @param lbModelDef
     * @param [recreate]
     */
    getMetaModelFromJuggler(modelName: string, lbModelDef: juggler.ModelDefinition, recreate?: boolean): MetaModel;
    protected addIndexDefinitions(metaModelRef: MetaModelRef, indexes: any): void;
    protected addForeignKeyDefinitions(metaModelRef: MetaModelRef, foreignKeys: any): void;
    /**
     * destroy a MetaModel by name
     *
     * @param modelName
     */
    destroyMetaModel(modelName: string): void;
    /**
     * destroy all models
     *
     */
    destroyAllMetaModels(): void;
    modelNames(): string[];
    /**
     * get the default table/column name for a given model/property name
     * @param name The name
     */
    dbName(modelOrProperty?: string): string | undefined;
}
export {};
