"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function callbackOnNextTick(cb, err, val) {
    process.nextTick(() => {
        cb(err, val);
    });
}
// if callback then call the callback from promise on next-tick
// always return void
function callbackify(promise, cb) {
    promise
        .then((val) => callbackOnNextTick(cb, undefined, val))
        .catch((err) => callbackOnNextTick(cb, err));
}
exports.callbackify = callbackify;
// if callback then call the callback and return void
// otherwise return the promise
function callbackifyOrPromise(promise, cb) {
    if (cb) {
        callbackify(promise, cb);
        // tslint:disable-next-line return-undefined
        return;
    }
    return promise;
}
exports.callbackifyOrPromise = callbackifyOrPromise;
//# sourceMappingURL=promise-callback.js.map